// Generated by CoffeeScript 1.10.0
(function() {
  var TilerSiblings, debug, defer,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  defer = require('node-promise').defer;

  debug = process.env["DEBUG"];

  TilerSiblings = (function() {
    TilerSiblings.CMD_SET_TILE = 'setTile';

    TilerSiblings.CMD_ADD_ITEM = 'addItem';

    TilerSiblings.CMD_REMOVE_ITEM = 'removeItem';

    TilerSiblings.CMD_UPDATE_ITEM = 'updateItem';

    TilerSiblings.CMD_ADD_ENTITY = 'addEntity';

    TilerSiblings.CMD_REMOVE_ENTITY = 'removeEntity';

    TilerSiblings.CMD_UPDATE_ENTITY = 'updateEntity';

    function TilerSiblings(myAddress, cacheEngine, modelEngine, sendFunction) {
      this.myAddress = myAddress;
      this.cacheEngine = cacheEngine;
      this.modelEngine = modelEngine;
      this.sendFunction = sendFunction;
      this.getSiblingsForZone = bind(this.getSiblingsForZone, this);
      this.deRegisterAsSiblingForZone = bind(this.deRegisterAsSiblingForZone, this);
      this.registerAsSiblingForZone = bind(this.registerAsSiblingForZone, this);
      this.sendCommand = bind(this.sendCommand, this);
    }

    TilerSiblings.prototype.sendCommand = function(zoneObj, cmd, arg1, arg2) {
      return this.getSiblingsForZone(zoneObj).then((function(_this) {
        return function(siblings) {
          var command;
          if (debug) {
            console.log('TilerSiblings.sendCommand got these siblings:' + JSON.stringify(siblings));
          }
          command = {
            cmd: cmd,
            arg1: arg1,
            arg2: arg2
          };
          if (arg1.toClient) {
            command.arg1 = arg1.toClient();
          }
          if (arg2.toClient) {
            command.arg2 = arg2.toClient();
          }
          return siblings.forEach(function(sibling) {
            if (sibling !== _this.myAddress) {
              return _this.sendFunction(sibling, command);
            }
          });
        };
      })(this));
    };

    TilerSiblings.prototype.registerAsSiblingForZone = function(zoneObj) {
      return this.cacheEngine.set('zonereplica_' + zoneObj.tileid + ':' + this.myAddress, this.myAddress);
    };

    TilerSiblings.prototype.deRegisterAsSiblingForZone = function(zoneObj) {
      return this.cacheEngine.del('zonereplica_' + zoneObj.tileid + ':' + this.myAddress);
    };

    TilerSiblings.prototype.getSiblingsForZone = function(zoneObj) {
      var q;
      q = defer();
      this.cacheEngine.getAllValuesFor('zonereplica_' + zoneObj.tileid + ':*').then((function(_this) {
        return function(replicaAddresses) {
          return q.resolve(replicaAddresses);
        };
      })(this));
      return q;
    };

    return TilerSiblings;

  })();

  module.exports = TilerSiblings;

}).call(this);

//# sourceMappingURL=TilerSiblings.js.map
